"use strict";

var oex = window.opera.extension, cfg = window.widget ? window.widget.preferences : {}, toutb, fields, keys, sieve_set, menu,
	input_changes = {},
	rgxNewLine = /(?:\n|\r\n?)+/,
	rgxHash = /^[^#]*#([^\/]+).*$/,
	LN = function (s) { return LNG[s] || s; };

window.onhashchange = function(e) {
	var args = [],
		old = e.oldURL.indexOf("#") > -1 ? e.oldURL.replace(rgxHash, "$1") : "viewer",
		hash = e.newURL.indexOf("#") > -1 ? e.newURL.substr(e.newURL.indexOf("#") + 1) : "viewer";

	if (hash.indexOf("/") > -1) {
		args = hash.split("/");
		hash = args.shift();
	}

	if (hash === "camera") {
		CameraUI.init();
	}
	else if (hash === "sieve") {
		sieveUI.load();
	}
	else if (hash === "gallery") {
		GalleryUI.init();
	}
	/*else if (hash === "info") {
		if (args[0] === "0") {
			document.getElementById("install").style.display = "block";
		}
		else if (args[0]) {
			alert("woohoooo " + args[0])
		}
	}*/

	if (old !== hash && window[old + "_sec"]) {
		(window[old + "_sec"].style.display = "none");
	}

	window[hash + "_sec"] && (window[hash + "_sec"].style.display = "block");

	menu.active && menu.active.classList.remove("active");
	(menu.active = menu.querySelector('a[href="#' + hash + '"]')) && menu.active.classList.add("active");
};

document.addEventListener("DOMContentLoaded", function() {
	var imagus_ver = document.getElementById("imagus_version");
	window.widget && (imagus_ver.textContent = widget.name + " v" + widget.version);

	if (!window.opera || window.opera.version() < 11.60) {
		document.body.outerHTML = '<body style="display:block"><a href="' + imagus_ver.nextElementSibling.href + '" class="fr">' + imagus_ver.textContent + '</a><div class="versionError">This extension works only in Opera 11.60 or above!<br><span style="font-size:12px">Your version: ' + window.opera.version() + " build " + window.opera.buildNumber() + '<br><br><a href="http://my.opera.com/community/download.pl?ref=Deathamns&p=opera_desktop">Install latest Opera!</a></div></body>';
		return;
	}

	for (var i = 0, els = document.body.querySelectorAll("[data-lng]"), l = els.length; i < l; ++i) {
		if (LNG[els[i].dataset["lng"]]) {
			els[i][els[i].dataset["lngattr"] || "innerHTML"] = LNG[els[i].dataset["lng"]];
		}
	}

	keys = document.querySelectorAll('input[name^="keys_"]');
	fields = document.querySelectorAll("input[name*=_], select[name*=_], textarea[name*=_]");

	load();

	menu = document.body.querySelector("nav");
	window.onhashchange({newURL: window.location.hash, oldURL: ""});

	document.body.style.display = "block";

	document.forms[0].onkeypress = function(e) {
		e.stopPropagation();

		if (e.keyCode === 13) {
			e.target.form_saved = true;;
		}

		if (!e.target.name || e.target.name.indexOf("keys_") !== 0 || e.keyCode < 32 || (e.keyCode === 46 && !e.which)) {
			return;
		}

		var key = e.which && String.fromCharCode(e.keyCode).trim().toUpperCase() || "", keyCode = key.charCodeAt(0);

		if (e.ctrlKey || e.altKey || e.metaKey || !key || "+-".indexOf(key) > -1) {
			return false;
		}

		keyCode = e.target.name.indexOf("-");
		keyCode = keyCode > 0 ? e.target.name.substring(4, keyCode) + "-" : false;

		for (var i = 0; i < keys.length; ++i) {
			if ((!keyCode || (keys[i].name.indexOf(keyCode) > 0 || keys[i].name.indexOf("-") < 0)) && keys[i].value.toUpperCase() === key) {
				return false;
			}
		}

		e.target.value = key;
		e.preventDefault();
		document.forms[0].onchange(e);
	};

	document.forms[0].oncontextmenu = function(e) {
		e.stopPropagation();

		if (!e.target.name || e.target.name.indexOf("_") === -1) {
			return;
		}

		if (e.ctrlKey) {
			e.preventDefault();
			setDefault(e.target);
			document.forms[0].onchange(e);
		}
		else if (e.shiftKey && e.target.name.indexOf("_") > -1) {
			e.preventDefault();
			alert(e.target.name + ": " + (e.target.type === "checkbox" ? e.target.checked : e.target.value));
		}
	};

	document.forms[0].onchange = function (e) {
		e.stopPropagation();

		var defval, t = e.target;

		if (t.form_saved) {
			delete t.form_saved;
		}
		else if (t.parentNode.dataset["form"] || t.parentNode.parentNode.dataset["form"]) {
			defval = "default";
		}
		else if (t.name.indexOf("_") > 0) {
			defval = "def";
		}

		if (!defval) {
			return;
		}

		if ((t.type === "checkbox" && t[defval + "Checked"] !== t.checked) || (t.type !== "checkbox" && t[defval + "Value"] != t.value)) {
			input_changes[t.name] = true;
		}
		else {
			delete input_changes[t.name];
		}

		if (Object.keys(input_changes).length) {
			document.getElementById("save_button").style.color = "#e03c00";
		}
		else {
			document.getElementById("save_button").style.color = "";
		}
	};

	document.getElementById("reset_button").onclick = function (e) {
		var rb = this;

		if (rb.pending) {
			input_changes["form_reset"] = true;
			clearTimeout(rb.pending);
			delete this.pending;
			rb.style.color = "";
			rb.nextElementSibling.style.color = "#e03c00";

			if (e.ctrlKey) {
				rb.style.color = "lime";
				e.preventDefault();
				e = (window.location.hash || "#viewer") + "_sec ";
				setDefault(e + "input," + e + "select," + e + "textarea");
			}
			else {
				rb.style.color = "green";
			}

			rb.pending = setTimeout(function () { delete rb.pending; rb.style.color = "#000"; }, 2000);
			return;
		}

		rb.style.color = "orange";

		rb.pending = setTimeout(function () {
			delete rb.pending;
			rb.style.color = "#000";
		}, 2000);

		e.preventDefault();
	};

	document.getElementById("save_button").onclick = function () {
		this.style.color = "green";
		clearTimeout(toutb);
		toutb = setTimeout(function(t) { return function() { t.style.color = ""; } }(this), 2000);
		save();
		return !1
	};
}, false);

var sieveUI = {
	loaded: false,
	lastClicked: null,
	cntr: 0,
	load: function (custom_sieve) {
		if (!custom_sieve && this.loaded) {
			return;
		}

		var name, sfrag = document.createDocumentFragment(), row;

		try {
			sieve_set = JSON.parse(custom_sieve || cfg.sieve || "{}");

			if (!Object.keys(sieve_set).length) {
				sieve_container.innerHTML = '<h3 class="container_info">' + LN("EMPTY") + '</h3>';
				return;
			}
		}
		catch (ex) {
			alert(LN("INVALIDFORMAT"));
			return;
		}

		for (name in sieve_set) {
			sfrag.appendChild(sieveUI.gen(name, sieve_set[name]));
		}

		sieve_container.innerHTML = "";
		sieve_container.appendChild(sfrag);

		if (sieve_container.onkeypress) {
			return;
		}

		sieve_container.onkeypress = function (e) {
			e.stopPropagation();
			var rname, t = e.target;

			if (t.nodeName !== "SPAN") {
				return;
			}

			if ((e.keyCode === 27 || e.keyCode === 13)) {
				e.preventDefault();

				rname = t.textContent.trim();

				if (e.keyCode === 27 && rname === "" && ![].some.call(t.parentNode.querySelectorAll('input[type="text"], textarea'), function (el) { return el.value.trim() !== ""; })) {
					t.parentNode.parentNode.removeChild(t.parentNode);
				}
				else {
					if (/^[^\r\n,]+$/.test(rname)) {
						t.textContent = rname;
						t.parentNode.querySelector('input[type="text"]').focus();
						t.contentEditable = false;
						t.className = "";
					}
					else {
						alert(LN("SIV_RULENAMECOND"));
					}
				}
			}
		};

		sieve_container.onmousedown = sieveUI.move;
		sieve_container.onclick = sieveUI.click;
		sieve_container.oncontextmenu = sieveUI.rename_del;

		name = document.getElementById("sieve_search");

		name.onkeypress = function (e) {
			if (e.keyCode === 27 || e.keyCode === 13) {
				e.preventDefault();
			}
		};

		name.onkeyup = function (e) {
			clearTimeout(this.timer);

			if (e.keyCode === 27) {
				this.value = "";
				sieveUI.search("");
				return;
			}
			else if (e.keyCode === 13) {
				sieveUI.search(this.value);

				var visibles = document.querySelectorAll('#sieve_container > div:not(.hidden)');

				if (visibles.length === 1) {
					visibles[0].classList.toggle('opened');
				}

				return;
			}

			this.timer = setTimeout(sieveUI.search, 300, this.value);
		};

		this.loaded = true;
	},
	gen: function (n, sd) {
		var vals, r = document.createElement("div"), c = ++this.cntr;

		sd = sd || {};
		sd.off && r.classList.add("disabled");
		r.rule = true;
		r.innerHTML = ['<span></span><div data-form="1">',
		'<label><input type="checkbox" name="useimg[' + c + ']"' + (sd.useimg && " checked") + '> ' + LN('SIV_USEIMG') + '</label>',
		'<label><input type="number" name="res_c[' + c + ']" min="0" max="1440" value="' + (sd.res_c || 0) + '"> ' + LN('SIV_CACHE_RES') + '</label>',
		'<input type="text" name="link[' + c + ']" placeholder="link" class="sieve_shorter_inp">',
		'<input type="checkbox" name="link_ci[' + c + ']"' + (sd.ci && (sd.ci & 1) ? " checked" : "") + ' title="' + LN('SIV_CI') + '">',
		'<input type="checkbox" name="link_dc[' + c + ']"' + (sd.dc && (sd.dc & 1) ? ' checked' : "") + ' title="' + LN('SIV_DECODE') + '">',
		'<input type="checkbox" name="link_loop[' + c + ']"' + (sd.loop && (sd.loop & 1) ? ' checked' : "") + ' title="' + LN('SIV_LOOP') + '">',
		'<input type="text" name="url[' + c + ']" placeholder="url">',
		'<textarea name="res[' + c + ']" placeholder="res"></textarea>',
		'<input type="text" name="img[' + c + ']" placeholder="img" class="sieve_shorter_inp">',
		'<input type="checkbox" name="img_ci[' + c + ']"' + (sd.ci && (sd.ci & 2) ? ' checked' : "") + ' title="' + LN('SIV_CI') + '">',
		'<input type="checkbox" name="img_dc[' + c + ']"' + (sd.dc && (sd.dc & 2) ? ' checked' : "") + ' title="' + LN('SIV_DECODE') + '">',
		'<input type="checkbox" name="img_loop[' + c + ']"' + (sd.loop && (sd.loop & 2) ? ' checked' : "") + ' title="' + LN('SIV_LOOP') + '">',
		'<textarea name="to[' + c + ']" placeholder="to"></textarea>',
		'<textarea name="note[' + c + ']" placeholder="note"></textarea></div>'].join("\n");

		n && (r.firstChild.textContent = n);

		vals = r.lastChild.children;
		sd.link && (vals[2].defaultValue = vals[2].value = sd.link);
		sd.url && (vals[6].defaultValue = vals[6].value = sd.url);
		sd.res && (vals[7].textContent = sd.res);
		sd.img && (vals[8].defaultValue = vals[8].value = sd.img);
		sd.to && (vals[12].textContent = sd.to);
		sd.note && (vals[13].textContent = sd.note);

		return r;
	},
	add: function () {
		sieve_container.insertBefore(this.gen(), sieve_container.firstElementChild);

		var rd = sieve_container.firstElementChild, rd_fc = rd.firstElementChild;
		rd_fc.contentEditable = true;
		rd_fc.className = "focus";
		rd.className = "opened";
		rd_fc.focus();
	},
	select: function (type) {
		for (var i = 0; i < sieve_container.childElementCount; ++i) {
			sieve_container.children[i].classList[type]("selected");
		}
	},
	click: function (e) {
		e.stopPropagation();

		if (e.target.nodeName !== "SPAN") {
			return;
		}

		if (e.button === 0) {
			if (e.shiftKey && sieveUI.lastClicked !== null) {
				var child = e.target.parentNode, currentIndex = 0, from, to, to_class = sieve_container.children[sieveUI.lastClicked].classList.contains("selected") ? "add" : "remove";

				while (child = child.previousElementSibling)	{
					currentIndex++;
				}

				from = Math.min(sieveUI.lastClicked, currentIndex);
				to = Math.max(sieveUI.lastClicked, currentIndex);

				for (; from <= to; ++from) {
					sieve_container.children[from].classList[to_class]("selected");
				}
			}
			else if (e.ctrlKey || e.metaKey) {
				sieveUI.lastClicked = 0;
				var child = e.target.parentNode;

				while (child = child.previousElementSibling) {
					sieveUI.lastClicked++;
				}

				e.target.parentNode.classList.toggle("selected");
				e.preventDefault();
			}
			else if (!e.target.isContentEditable) {
				e.target.parentNode.classList.toggle("opened");
			}
		}
	},
	move: function (e) {
		e.stopPropagation();

		var div = e.target.parentNode, i, list;

		if (e.target.isContentEditable || e.target.nodeName !== "SPAN" || div.classList.contains("opened") || e.button !== 0 ) {
			return;
		}

		e.preventDefault();

		document.onmousemove = function (e) {
			if (!div.classList.contains("move")) {
				div.classList.add("move");

				list = sieve_container.querySelectorAll((div.classList.contains("selected") ? ".selected, " : "") + ".move");

				for (i = 0; i < list.length; ++i) {
					if (div !== list[i]) {
						list[i].classList.add("move_multi");
					}
				}
			}

			div.style.cssText = "left:" + (e.clientX + 15) + "px;top:" + (e.clientY + 15) + "px";
		};

		document.onmouseup = function (e) {
			if (div.classList.contains("move") && e.target.parentNode.rule) {
				var dcfr = document.createDocumentFragment();

				for (i = 0; i < list.length; ++i) {
					sieve_container.removeChild(list[i]);
					dcfr.appendChild(list[i]);
				}

				sieve_container.insertBefore(dcfr, e.target.parentNode);
			}

			div.classList.remove("move");
			list = sieve_container.querySelectorAll(".move_multi");

			for (i = 0; i < list.length; ++i) {
				list[i].classList.remove("move_multi");
			}

			sieve_container.onmouseover = document.onmouseup = document.onmousemove = null;
		};
	},
	imprt: function (file) {
		var reader = new FileReader();

		reader.onload = function(e) {
			try {
				if (!cfg.sieve || cfg.sieve === "{}" || confirm(LN("SIV_UPDALERT"))) {
					sieveUI.load(e.target.result);
				}
			}
			catch (ex) {
				alert(LN("INVALIDFORMAT"));
			}
		};

		reader.readAsText(file);
	},
	exprt: function () {
		if (sieve_container.childElementCount) {
			var i, list = sieve_container.querySelectorAll("div.selected"), exp = {};

			if (list.length) {
				for (i = 0; i < list.length; ++i) {
					exp[list[i].firstElementChild.textContent] = sieve_set[list[i].firstElementChild.textContent];
				}
			}
			else {
				exp = sieve_set;
			}

			if ((exp = JSON.stringify(exp)) !== "{}") {
				oex.postMessage({"cmd": "open", "url": "data:application/x-javascript," + escape(exp)});
			}
		}
	},
	disable: function () {
		var i = sieve_container.childElementCount, list = sieve_container.querySelectorAll("div.selected").length, cn = sieve_container.children;

		while (i--) {
			if (!list || cn[i].classList.contains("selected")) {
				cn[i].classList.toggle("disabled");
			}
		}
	},
	remove: function () {
		if (confirm(LN("DELITEMS"))) {
			var i = 0, list = sieve_container.querySelectorAll("div.selected");

			if (list.length) {
				for (;i < list.length; ++i) {
					sieve_container.removeChild(list[i]);
				}
			}
			else {
				sieve_container.innerHTML = "";
			}
		}
	},
	rename_del: function (e) {
		e.stopPropagation();

		if (e.target.nodeName !== "SPAN") { return; }

		if (e.shiftKey) {
			e.preventDefault();
			e.target.textContent = e.target.textContent.trim();
			e.target.contentEditable = !e.target.isContentEditable;
			e.target.className = e.target.isContentEditable ? "focus" : "";
		}
		else if (e.ctrlKey) {
			if (confirm(LN("AREYOUSURE"))) {
				e.target.parentNode.parentNode.removeChild(e.target.parentNode);
			}

			e.preventDefault();
		}
	},
	search: function (what) {
		var list = sieve_container.children, i = list.length;
		what = new RegExp(what, "i");

		while (i--) {
			list[i].classList[what.test(list[i].firstElementChild.textContent) ? 'remove' : 'add']("hidden");
		}
	},
	update: function () {
		if (!cfg.sieve || cfg.sieve === "{}" || confirm(LN("SIV_UPDALERT"))) {
			cfg.removeItem("sieve");
			oex.bgProcess.update_prefs();
			setTimeout(function() {
				window.location.reload();
			}, 2000);
		}
	}
},
GalleryUI = {
	loaded: false,
	page: 1,
	pages: 1,
	where: null,
	orderby: "date DESC",
	ipp: 20,
	total: 0,
	search_f: null,
	rgxName: /[^\/]*$/,
	rgxEscape: /(%|_|")/g,
	init: function () {
		if (GalleryUI.loaded) {
			return;
		}

		this.search_f = document.getElementById("gallery_search");
		this.search_f.onkeypress = function (e) {
			clearTimeout(this.timeout);

			if (e.keyCode === 27) {
				this.value = "";
				GalleryUI.search();
				e.preventDefault();
			}
			else {
				if (e.keyCode === 13) {
					GalleryUI.search();
					e.preventDefault();
				}
				else {
					this.timeout = setTimeout(GalleryUI.search, 300);
				}
			}
		};

		gallery_container.nextElementSibling.onclick = gallery_container.previousElementSibling.onclick = function (e) {
			if (e.target.nodeName.toUpperCase() === "A") {
				GalleryUI.page = e.target.textContent;
				GalleryUI.load();
			}
		};

		GalleryUI.loaded = true;
		GalleryUI.load();
	},
	drop: function (force) {
		if (force || confirm(LN("DELITEMS"))) {
			var remove = gallery_container.querySelectorAll("div.selected");

			if (remove.length) {
				this.remove(remove);
			}
			else {
				gallery_container.innerHTML = '<h3 class="container_info">' + LN("EMPTY") + "</h3>";
				gallery_container.nextElementSibling.innerHTML = gallery_container.previousElementSibling.innerHTML = "";
				!force && oex.bgProcess.SQL.run("DELETE FROM gallery");
			}
		}
	},
	gen: function (r) {
		var labels, source = "", tmpdiv = document.createElement("div");

		labels = r.label === null ? "" : r.label.split(",").map(function (label) { return '<b>' + label + "</b>"} ).join(" ");

		if (r.source !== null) {
			var lng_code = {"s": "GAL_SOURCE", "t": "GAL_TARGET"};
			r.source.split("\n").forEach(function (el) {
				var fc = el.charAt(0);

				if (lng_code[fc]) {
					source += '<a href="' + el.substr(2) + '" class="gal_im_source">' + LN(lng_code[fc]) + "</a>";
				}
			});
		}

		tmpdiv.innerHTML = '<a href="' + r.image + '" ' + (r.thumb ? 'class="thumb" ' : "") + 'rel="nofollow">' +
			(r.thumb === null ? decodeURIComponent(r.image.match(this.rgxName)[0]) : '<div class="gal_im" style="height:' + Math.min(Math.round(Math.min(r.width, 110) * r.height / r.width), 200) + 'px;background-image:url(data:image/jpeg;base64,' + r.thumb + ')"><span class="gal_im_span">' + r.width + 'x' + r.height + '</span><br><span class="gal_im_span">' + decodeURIComponent(r.image.match(this.rgxName)[0]) + '</span></div>') +
			'<b class="gal_im_date">' + r.date + "</b></a>" +
			(source ? '<div>' + source + "</div>" : "") +
			(labels ? '<div class="gal_im_labels">' + labels + "</div>" : "");

		tmpdiv.onclick = this.onClick;
		tmpdiv.oncontextmenu = this.onContextmenu;

		return tmpdiv;
	},
	onClick: function (e) {
		if (e.button === 0) {
			if (e.ctrlKey) {
				e.preventDefault();
				this.classList.toggle("selected");
			}
			else if (e.target.parentNode && e.target.parentNode.className === "gal_im_labels") {
				GalleryUI.search_f.value = e.target.textContent;
				GalleryUI.search_f.focus();
			}
		}
	},
	onContextmenu: function (e) {
		if (e.ctrlKey) {
			e.preventDefault();

			if (confirm(LN("AREYOUSURE"))) {
				this.classList.contains("selected") ? GalleryUI.drop(true) : GalleryUI.remove([this]);
			}
		}
		else if (e.shiftKey) {
			var labels = window.prompt(LN("GAL_EDITLABELS"),
				(this.lastElementChild.className === "gal_im_labels" ? [].map.call(this.lastElementChild.children, function (el) { return el.textContent; }).join(", ") : ""));

			if (labels !== null) {
				oex.postMessage({"cmd": "gallery", "data": {"image": this.firstElementChild.href, "label": labels, "nobubble": true}});
				GalleryUI.search_f.onkeypress({"keyCode": 0});
			}

			e.preventDefault();
		}
	},
	limit: function () {
		var limit;

		if (GalleryUI.pages === GalleryUI.page) {
			limit = GalleryUI.total % GalleryUI.ipp;

			if (limit === 0) {
				limit = GalleryUI.ipp;
			}
		}
		else {
			limit = GalleryUI.ipp;
		}

		return " LIMIT " + (GalleryUI.ipp * (GalleryUI.page - 1)) + " ," + limit;
	},
	load: function () {
		if (this.process) {
			return;
		}
		else {
			this.process = true;
		}

		var where = GalleryUI.where ? ' WHERE ' + GalleryUI.where.join(' AND '): "";

		oex.bgProcess.SQL.run("SELECT COUNT(*) AS c FROM gallery" + where, [], function (qcq, qcr) {
			GalleryUI.total = qcr.rows[0].c;

			if (GalleryUI.total < 1) {
				if (GalleryUI.where) {
					gallery_container.innerHTML = '<h3 class="container_info">' + LN('NOMATCH') + '</h3>';
				}
				else {
					GalleryUI.drop(true);
				}

				gallery_container.nextElementSibling.innerHTML = gallery_container.previousElementSibling.innerHTML = "";
			}
			else {
				if (GalleryUI.total <= GalleryUI.ipp) {
					GalleryUI.pages = GalleryUI.page = 1;
				}
				else {
					GalleryUI.pages = Math.ceil(GalleryUI.total / GalleryUI.ipp);
					GalleryUI.page = Math.max(1, Math.min(GalleryUI.page, GalleryUI.pages));
				}

				oex.bgProcess.SQL.run("SELECT * FROM gallery" + where + " ORDER BY " + GalleryUI.orderby + GalleryUI.limit(), [], function (tx, r) {
					var i, l = r.rows.length, dfrag = document.createDocumentFragment(), pages = [];

					if (GalleryUI.pages > 1) {
						for (i = 1; i <= GalleryUI.pages; ++i) {
							pages.push("<a" + (GalleryUI.page === i ? ' class="pager_a_active"' : "") +">" + i + "</a>");
						}

						i = (GalleryUI.page - 1) * GalleryUI.ipp;
						pages = '<b class="pager_data">' + (i + 1) + " - " + (i + r.rows.length) + " ... " + GalleryUI.total + "</b> " + pages.join(" ");
					}

					gallery_container.previousElementSibling.innerHTML = gallery_container.nextElementSibling.innerHTML = pages;

					i = 0;
					while (l = r.rows[i++]) {
						dfrag.appendChild(GalleryUI.gen(l));
					}

					gallery_container.innerHTML = "";
					gallery_container.appendChild(dfrag);
				});
			}

			GalleryUI.process = false;
		});
	},
	imprt: function (file) {
		var reader = new FileReader();

		reader.onload = function(e) {
			try {
				var data = JSON.parse(e.target.result);

				oex.bgProcess.SQL.db.transaction(function(q) {
					var i, j, insert_cols, row_data, col_names = ["date", "label", "source"];

					for (i in data) {
						insert_cols = [""];
						row_data = [i];

						for (j = 0; j < 3; ++j) {
							if (data[i][col_names[j]]) {
								insert_cols.push(col_names[j]);
								row_data.push(data[i][col_names[j]]);
							}
						}

						q.executeSql("REPLACE INTO gallery (image" + insert_cols.join(", ") + ") VALUEs (" + Array(row_data.length + 1).join("?, ").slice(0, -2) + ")", row_data);
					}

					if (insert_cols) {
						oex.bgProcess.regenerate_missing_thumbnails();
						window.location.reload();
					}
				});
			}
			catch (ex) {
				alert(LN("INVALIDFORMAT"));
			}
		};

		reader.readAsText(file);
	},
	exprt: function () {
		var where = [];

		[].forEach.call(gallery_container.querySelectorAll("div.selected"), function (el) {
			where.push(el.firstElementChild.href);
		});

		oex.bgProcess.SQL.run("SELECT image, date, source, label FROM gallery" + (where.length ? " WHERE image IN (" + Array(where.length + 1).join("?, ").slice(0, -2) + ")" : "") + " ORDER BY " + GalleryUI.orderby, where, function (tx, r) {
			var i, l = r.rows.length, exp_data = {}, tmp_obj, row;

			for (i = 0; i < l; ++i) {
				row = r.rows[i];
				tmp_obj = {date: row.date};

				row.label && (tmp_obj.label = row.label);
				row.source && (tmp_obj.source = row.source);

				exp_data[row.image] = tmp_obj;
			}

			tmp_obj && oex.postMessage({"cmd": "open", "url": "data:application/x-javascript," + escape(JSON.stringify(exp_data))});
		});
	},
	search: function () {
		var s = GalleryUI.search_f.value;

		if (s) {
			s = ' LIKE "%' + s.replace(GalleryUI.rgxEscape, '\\$1') + "%\" ESCAPE '\\'";
			GalleryUI.where = ["image" + s + " OR label" + s];
		}
		else {
			GalleryUI.where = null;
		}

		GalleryUI.load();
	},
	remove: function (elems) {
		var to_remove = [];

		[].forEach.call(elems, function (el) {
			to_remove.push(el.firstElementChild.href);
			el.parentNode.removeChild(el);
		});

		oex.bgProcess.SQL.run("DELETE FROM gallery WHERE image IN (" + Array(to_remove.length + 1).join("?, ").slice(0, -2) + ")", to_remove);
		GalleryUI.load();
	}
},
CameraUI = {
	loaded: false,
	flip_state: {h: 1, v: 1},
	timer: null,
	init: function () {
		if (this.loaded) {
			return;
		}

		this.loaded = true;

		if (navigator.getUserMedia) {
			navigator.getUserMedia({"audio": false, "video": true}, function (stream) { video.src = stream; }, function (error) { camera_sec.innerHTML = "<h3>Couldn't get the stream...</h3>"; });
		}
		else {
			camera_sec.innerHTML = "<h3>getUserMedia is unavailable...</h3>";
		}
	},
	flip: function (v) {
		if (v) {
			this.flip_state.v = this.flip_state.v === 1 ? -1 : 1;
		}
		else {
			this.flip_state.h = this.flip_state.h === 1 ? -1 : 1;
		}

		video.style.OTransform = "scale(" + this.flip_state.h + ", " + this.flip_state.v + ")";
	},
	capture: function () {
		var
			c = document.createElement("canvas"),
			ctx = c.getContext("2d"),
			shots = document.getElementById("shots");

		c.width = video.videoWidth;
		c.height = video.videoHeight;

		c.style.maxWidth = 160 + "px";
		c.style.maxHeight = (160 * c.height / c.width) + "px";

		if (CameraUI.flip_state.h === -1 || CameraUI.flip_state.v === -1) {
			ctx.translate(CameraUI.flip_state.h === -1 ? c.width : 0, CameraUI.flip_state.v === -1 ? c.height : 0);
			ctx.scale(CameraUI.flip_state.h, CameraUI.flip_state.v);
		}

		ctx.drawImage(video, 0, 0);

		if (shots.childElementCount > 15) {
			shots.removeChild(shots.lastElementChild);
		}

		shots.insertBefore(c, shots.firstChild);
	},
	shoot: function(s) {
		clearTimeout(this.timer);
		this.timer = setTimeout(this.capture, s * 1000);
	}
};

function setDefault(query) {
	query && [].forEach.call(typeof query === "string" ? document.querySelectorAll(query) : [query], function (el) {
		if (el.type === "checkbox") {
			el.checked = el.defaultChecked;
		}
		else if (/^SELECT/i.test(el.type)) {
			for (var i = el.length; i--;) {
				if (el[i].hasAttribute("selected")) {
					el.selectedIndex = i;
					break;
				}
			}
		}
		else {
			el.value = el.defaultValue;
		}
	});
}

function load() {
	var i = fields.length, m, fld, mode, pref, prefs = {};

	while (i--) {
		fld = fields[i];

		if (fld.disabled || fld.readOnly) {
			continue;
		}

		pref = fld.name.split("_");

		if (!prefs[pref[0]]) {
			try {
				prefs[pref[0]] = JSON.parse(cfg[pref[0]] || "{}");
			}
			catch (ex) {
				prefs[pref[0]] = cfg[pref[0]];
			}
		}

		if (pref[0] === "tls" && pref[1] === "sendToHosts") {
			if (Array.isArray(prefs.tls[pref[1]])) {
				var shidx, shosts = [];

				for (shidx = 0; shidx < prefs.tls[pref[1]].length; ++shidx) {
					shosts.push(prefs.tls[pref[1]][shidx].join("|"));
				}

				fld.rows = shosts.length;
				fld.value = fld.defValue = shosts.join("\n");
			}
		}
		else if (pref[0] === "grants") {
			shosts = [];
			m = prefs.grants;

			if (m && m.length) {
				for (shidx = 0; shidx < m.length; ++shidx) {
					shosts.push(m[shidx].op + (m[shidx].rules || m[shidx].opts || "") + ":" + m[shidx].url);
				}
			}

			fld.value = fld.defValue = shosts.join("\n");
		}
		else if (pref[0] === "keys") {
			m = pref[1].replace("-", "_");
			(prefs.keys[m] !== undefined) && (fld.value = fld.defValue = prefs.keys[m].toUpperCase());
		}
		else {
			if (prefs[pref[0]] && prefs[pref[0]][pref[1]] !== undefined) {
				if (fld.type === "checkbox") {
					fld.checked = fld.defChecked = !!prefs[pref[0]][pref[1]];
				}
				else {
					fld.value = fld.defValue = prefs[pref[0]][pref[1]];

					if (fld.type === "range") {
						m = fld.nextElementSibling;

						if (m && m.type === "color") {
							m.style.opacity = fld.value;
						}

						m = fld.previousElementSibling;

						if (m && m.nodeName === "OUTPUT") {
							m.value = fld.value;
						}

						fld.addEventListener("change", function () { this.previousElementSibling.value = this.value; });
					}
					else if (fld.type === "text" && fld.previousElementSibling && fld.previousElementSibling.type === "color") {
						fld.onchange = function () {
							this.previousElementSibling.value = /^#[\da-f]{6}/i.test(this.value) ? this.value : "#ffffff";
						};

						fld.onchange();

						fld.previousElementSibling.onchange = function () {
							this.nextElementSibling.value = this.value;
						};
					}
				}
			}
		}
	}

	GalleryUI.ipp = prefs.tls.galIPP;
}

function save() {
	var i, j, m, fld, pref, prefs = {},
		host, shidx, shosts,
		rgxGrant = /^([!~]{1,2})((?:[^,:]+,?\s*)+)?:(.+)/,
		rgxWhitespace = /\s+/g,
		options, rule,
		rules = document.querySelectorAll("#sieve_container > div"),
		rl = rules.length,
		param, opt_name;

	prefs.sieve = null;

	if (sieveUI.loaded || rl) {
		prefs.sieve = {};

		for (i = 0; i < rl; ++i) {
			rule = rules[i].firstElementChild.textContent.trim().replace(rgxWhitespace, " ");

			if (!rule) {
				return;
			}

			prefs.sieve[rule] = {};
			rule = prefs.sieve[rule];

			if (rules[i].classList.contains("disabled")) {
				rule.off = 1;
			}

			options = rules[i].querySelectorAll("input, textarea");

			for (j = 0; j < options.length; ++j) {
				param = options[j].name.substr(0, options[j].name.indexOf("["));

				switch (param) {
					case "useimg":
						if (options[j].checked) {
							rule["useimg"] = 1;
						}
					break;
					case "res_c":
						if (options[j].valueAsNumber) {
							rule["res_c"] = options[j].valueAsNumber;
						}
					break;
					case "note":
						options[j].value = options[j].value.trim();
					case "link": case "url": case "res": case "img": case "to":
						if (options[j].value !== "") {
							rule[param] = options[j].value.replace(/\r\n?/g, "\n");
						}
					break;

					case "link_ci": case "img_ci":
					case "link_dc": case "img_dc":
					case "link_loop": case "img_loop":
						opt_name = param.split("_");
						param = opt_name[1];
						opt_name = opt_name[0];

						if (rule[opt_name] && options[j].checked) {
							opt_name = (rule[param] || 0) | (opt_name === "link" ? 1 : 2);

							if (opt_name) {
								rule[param] = opt_name;
							}
						}
					break;
				}
			}
		}
	}

	for (i = 0; i < fields.length; ++i) {
		fld = fields[i];

		if (fld.readOnly) {
			continue;
		}

		pref = fld.name.split("_");

		if (!prefs[pref[0]]) {
			prefs[pref[0]] = {};
		}

		if (pref[0] === "tls" && pref[1] === "sendToHosts") {
			shosts = fld.value.trim().split(rgxNewLine);
			prefs.tls[pref[1]] = [];

			for (shidx = 0; shidx < shosts.length; ++shidx) {
				host = shosts[shidx].split("|");

				if (host.length === 2) {
					prefs.tls[pref[1]].push(host);
				}
			}
		}
		else if (pref[0] === "grants") {
			prefs.grants = [];

			if (fld.value === "") {
				continue;
			}

			var grnts = fld.value.trim().split(rgxNewLine), grant;

			if (!grnts.length) {
				continue;
			}

			sieve_set = prefs.sieve || JSON.parse(cfg.sieve || "{}");

			for (shidx = 0; shidx < grnts.length; ++shidx) {
				if (grant = grnts[shidx].match(rgxGrant)) {
					host = {op: grant[1], url: grant[3]};

					if (grant[2]) {
						/*if (host.op[0] === "@") {
							host.opts = {};
							var rgxOpt = /(?:(?:vw|hz|keys|tls){(?:[\w-]+\s*:\s*(?:true|false|\d+|"[^"\\]*(?:\\.[^"\\]*)*"),?)+})/g;

							console.log(grant[2], grant[2].match(rgxOpt));
							//@@hz{zoomResized:0}vw{caption:true}:^https?://maps\.google\.
							/(@@?)((?:hz|vw|keys|tls)\|(?:[\w\-]+:\s*(?:true|false|-?\d+(?:\.\d+)?|"[^"\\]*(?:\\.[^"\\]*)*");?)+)+:(.+)/ 
return;
						}
						else {*/
							host.rules = grant[2].split(/\s*,\s*/).filter(function (el) {
								return !!sieve_set[el];
							});

							if (!host.rules.length) {
								delete host.rules;
							}
						//}
					}

					prefs.grants.push(host);
				}
			}

			fld.value = prefs.grants.map(function (el) { return el.op + (el.rules || el.opts || "") + ":" + el.url }).join("\n");
		}
		else if (pref[0] === "keys") {
			m = pref[1].replace("-", "_");
			prefs.keys[m] = fld.value = fld.value.toUpperCase();
		}
		else {
			if (prefs[pref[0]]) {
				if (fld.type === "checkbox") {
					prefs[pref[0]][pref[1]] = fld.checked
				}
				else if (fld.type === "range" || fld.type === "number" || fld.classList.contains("number")) {
					prefs[pref[0]][pref[1]] = fld.min ? Math.max(fld.min, Math.min(fld.max, parseFloat(fld.value))) : parseFloat(fld.value);
					fld.value = prefs[pref[0]][pref[1]];
				}
				else {
					prefs[pref[0]][pref[1]] = fld.value;
				}
			}
		}
	}

	oex.postMessage({"cmd": "broadcast", "data": "reinit", "prefs": prefs});
	GalleryUI.ipp = prefs.tls.galIPP || GalleryUI.ipp;
	GalleryUI.load();
}

function prefs(data) {
	var i, pref_keys = ["vw", "hz", "keys", "tls", "grants"];

	if (data) {
		var reader = new FileReader();

		reader.onload = function(e) {
			try {
				data = JSON.parse(e.target.result);

				var keys = [];

				for (i in data) {
					if (pref_keys.indexOf(i) > -1) {
						keys.push(i);
					}
				}

				if (!keys.length) {
					alert(LN("PREF_NOIMP"));
					return;
				}
				else if (!window.confirm(LN("PREF_OVERWRITE") + "\n\n" + keys.join(", "))) {
					return;
				}

				for (i = 0; i < keys.length; ++i) {
					cfg[keys[i]] = JSON.stringify(data[keys[i]]);
				}

				window.location.reload(true);
			}
			catch (ex) {
				alert(LN("INVALIDFORMAT"));
			}
		};

		reader.readAsText(data);
		return;
	}

	data = {};

	for (i = 0; i < 5; ++i) {
		if (cfg[pref_keys[i]]) {
			data[pref_keys[i]] = JSON.parse(cfg[pref_keys[i]]);
		}
	}

	oex.postMessage({"cmd": "open", "url": "data:application/x-javascript," + escape(JSON.stringify(data))});
}